#include <stdio.h>
#include <float.h>
#include <math.h>
/*
#include "stdio.h"
#include "float.h"
#include "math.h"
*/

double arc_sinh(double u);
double arc_tanh(double u);
double arc_cosh(double u);
long double arc_sinhl(long double u);
long double arc_tanhl(long double u);
long double arc_coshl(long double u);

void main() {
     int i;
     double u,v,w;
     long double r,s,t;

     printf ("\n Inverse Hyperbolic Test\n");
     for (i=-30; i<=10; i++) {
	 u = -pow (10.0e+000, ((double) i / (double) 10));
	 r = -powl (10.0e+0000L, ((long double) i / (long double) 10));
	 printf ("\nu is %22.15lg\n",u);

	 v = arc_sinh( w=sinh(u) ) - u;
	 s = arc_sinhl( t=sinhl(r) ) - r;
	 printf ("Arcsinh(sinh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
	 printf ("Sinh(u) = %22.15lg, %28.21Lg \n",w,t);

	 v = arc_tanh( w=tanh(u) ) - u;
	 s = arc_tanhl( t=tanhl(r) ) - r;
	 printf ("Arctanh(tanh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
	 printf ("Tanh(u) = %22.15lg, %28.21Lg \n",w,t);
     };

     u = 0.0;
     r = 0.0;
     printf ("\nu is %22.15lg\n",u);

     v = arc_sinh( w=sinh(u) ) - u;
     s = arc_sinhl( t=sinhl(r) ) - r;
     printf ("Arcsinh(sinh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
     printf ("Sinh(u) = %22.15lg, %28.21Lg \n",w,t);

     v = arc_tanh( w=tanh(u) ) - u;
     s = arc_tanhl( t=tanhl(r) ) - r;
     printf ("Arctanh(tanh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
     printf ("Tanh(u) = %22.15lg, %28.21Lg \n",w,t);

     for (i=-30; i<=10; i++) {
	 u = pow (10.0e+000, ((double) i / (double) 10));
	 r = powl (10.0e+0000L, ((long double) i / (long double) 10));
	 printf ("\nu is %22.15lg\n",u);

	 v = arc_sinh( w=sinh(u) ) - u;
	 s = arc_sinhl( t=sinhl(r) ) - r;
	 printf ("Arcsinh(sinh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
	 printf ("Sinh(u) = %22.15lg, %28.21Lg \n",w,t);

	 v = arc_tanh( w=tanh(u) ) - u;
	 s = arc_tanhl( t=tanhl(r) ) - r;
	 printf ("Arctanh(tanh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
	 printf ("Tanh(u) = %22.15lg, %28.21Lg \n",w,t);

	 v = arc_cosh( w=cosh(u) ) - u;
	 s = arc_coshl( t=coshl(r) ) - r;
	 printf ("Arccosh(cosh(u)) - u is %22.15lg, %28.21Lg\n",v,s);
	 printf ("Cosh(u) = %22.15lg, %28.21Lg \n",w,t);
     }
}
